freeslot("sfx_smwswm")

sfxinfo[sfx_smwswm].caption = "Swim"

freeslot("S_SMW_SWIM", "S_SMW_SWIMIDLE")

states[S_SMW_SWIM] = {
    sprite = SPR_PLAY,
    frame = SPR2_SWIM|FF_SPR2ENDSTATE,
    tics = 4,
    nextstate = S_SMW_SWIM,
	var1 = S_SMW_SWIMIDLE
}

states[S_SMW_SWIMIDLE] = {
    sprite = SPR_PLAY,
    frame = SPR2_SWIM,
    tics = -1,
    nextstate = S_SMW_SWIMIDLE
}

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "smwmario" and p.mo.skin ~= "smwluigi"
	or ((p.pflags & PF_FINISHED) or p.exiting) return end
	
	if p.smwjumpheld == nil
		p.smwjumpheld = 0
	end
	
	if (p.cmd.buttons & BT_JUMP)
	and not ((p.pflags & PF_JUMPSTASIS) or (p.pflags & PF_FULLSTASIS))
		p.smwjumpheld = $+1
	else
		p.smwjumpheld = 0
	end
	
	if (p.mo.eflags & MFE_UNDERWATER)
	and not (p.smwgainpup or p.smwlosepup)
	and not (P_PlayerInPain(p) or p.playerstate == PST_DEAD)
		p.powers[pw_underwater] = 0
		if p.smwjumpheld == 1
		and not p.smwslide
			p.pflags = $ & ~PF_JUMPED
			S_StartSound(p.mo, sfx_smwswm)
			--P_DoJump(p, false)
			local momz = 4*FU
			local momz2 = 8*FU
			if (p.cmd.buttons & BT_CUSTOM3)
				momz = 6*FU
				momz2 = 10*FU
			elseif (p.cmd.buttons & BT_CUSTOM2)
				momz = 2*FU
				momz2 = 4*FU
			end
			P_SetObjectMomZ(p.mo, momz, true)
			if (p.mo.momz > momz2 and not (p.mo.eflags & MFE_VERTICALFLIP))
			or (p.mo.momz < -momz2 and (p.mo.eflags & MFE_VERTICALFLIP))
				P_SetObjectMomZ(p.mo, momz2)
			end
			p.mo.state = S_SMW_SWIM
			p.mo.frame = A
		end
		if not (p.mo.state >= S_SMW_SWIM and p.mo.state <= S_SMW_SWIMIDLE)
		and not P_IsObjectOnGround(p.mo)
			p.mo.state = S_SMW_SWIMIDLE
		end
	elseif (p.mo.state >= S_SMW_SWIM and p.mo.state <= S_SMW_SWIMIDLE)
		p.mo.state = S_PLAY_JUMP
	end
	
	if p.mo.state == S_SMW_SWIMIDLE
	and p.mo.frame ~= A
		p.mo.frame = A
	end
end)

local function bubblething(mo, pmo)
	if not (pmo and pmo.valid)
	or not (pmo.player and pmo.player.valid)
	or pmo.skin ~= "smwmario" and pmo.skin ~= "smwluigi" return end
	
	return false
end

addHook("MobjCollide", bubblething, MT_EXTRALARGEBUBBLE)
addHook("MobjMoveCollide", bubblething, MT_EXTRALARGEBUBBLE)