
-- the abilities of the cape feather
-- excluding flying, that's going to be a seperate lua

freeslot("S_SMW_CFSPIN")

states[S_SMW_CFSPIN] = {
    sprite = SPR_PLAY,
    frame = SPR2_SJUM|FF_ANIMATE,
    tics = -1,
    nextstate = S_PLAY_FALL,
	var1 = D,
	var2 = 2
}

local function canSpin(p)
	if P_PlayerInPain(p)
	or p.playerstate == PST_DEAD
	or p.smwgrab
	or p.smwpbaloon
	or ((p.pflags & PF_FINISHED) or p.exiting)
	or (p.pflags & PF_STASIS)
		return false
	end
	return true
end

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "smwmario" and p.mo.skin ~= "smwluigi" return end
	
	if p.smwpowerup == 3
		if ((p.cmd.buttons & BT_JUMP) or (p.cmd.buttons & BT_CUSTOM1))
		and not ((p.pflags & PF_JUMPSTASIS) or (p.pflags & PF_FULLSTASIS))
		and ((p.mo.momz < -3*FU and not (p.mo.eflags & MFE_VERTICALFLIP)) or (p.mo.momz > 3*FU and (p.mo.eflags & MFE_VERTICALFLIP)))
		and not (p.mo.eflags & MFE_UNDERWATER)
		and not p.smwpbaloon
			P_SetObjectMomZ(p.mo, -3*FU)
		end
		
		if p.smwspheld == 1
		and not p.smwspinjump
		and not p.smwcrouch
		and not p.smwslide
		and canSpin(p)
			p.smwcfstime = 0
			p.smwcfspin = true
			p.smwcfang = camera.angle+ANGLE_90
			S_StartSound(p.mo, sfx_smwsj)
		end
	end
	
	if p.smwcfspin
		p.powers[pw_strong] = $1|STR_PUNCH|STR_TAIL|STR_WALL|STR_ANIM
		P_RadiusAttack(p.mo, p.mo, 80*FU)
		if p.mo.state ~= S_SMW_CFSPIN
			p.mo.state = S_SMW_CFSPIN
		end
		p.smwcfstime = $+1
		if not canSpin(p)
		or p.smwcfstime >= TICRATE/2-TICRATE/4
			p.smwcfspin = false
		end
		p.drawangle = p.smwcfang
		p.smwcfang = $+ANGLE_45
	elseif p.smwcfstime ~= 0
		p.smwcfstime = 0
	elseif p.mo.state == S_SMW_CFSPIN
		if p.mo.momz > 0
			p.mo.state = S_PLAY_JUMP
		else
			p.mo.state = S_PLAY_FALL
		end
	end
end)