
-- everything related to flying
-- like the "takeoff meter" and actually flying

addHook("JumpSpecial", function(p)
	if P_IsObjectOnGround(p.mo)
	and p.normalspeed >= 36*FRACUNIT 
	and p.smwpowerup == 3
	and not p.smwcfflight
		p.smwcftometer = 80
	end
end)

addHook("PlayerSpawn", function(p)
	p.smwcftometer = 0
end)

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "smwmario" and p.mo.skin ~= "smwluigi" return end
	
	if p.smwcftometer == nil
		p.smwcftometer = 0
	end
	
	if p.smwcftometer
		p.smwcftometer = $-1
		if ((p.cmd.buttons & BT_JUMP) or (p.cmd.buttons & BT_CUSTOM1))
		and not P_IsObjectOnGround(p.mo)
			P_SetObjectMomZ(p.mo, 10*FU)
		end
		
		if ((p.mo.momz < 0 and not (p.mo.eflags & MFE_VERTICALFLIP)) or (p.mo.momz > 0 and (p.mo.eflags & MFE_VERTICALFLIP)))
		and not p.smwmaxrunspeed
		or p.smwcftometer == 1
		or (p.mo.eflags & MFE_UNDERWATER)
			p.smwcftometer = 0
			if not (p.mo.eflags & MFE_UNDERWATER)
				p.smwcfflight = false
			end
		end	
	end
end)

addHook("ShouldDamage", function(pmo)
	if not (pmo and pmo.valid)
	or pmo.skin ~= "realsmwluigi"
	or not pmo.player.smwcfflight return end
	
	local p = pmo.player
	
	p.smwcfflight = false
	p.powers[pw_flashing] = 3*TICRATE-1
	return false
end, MT_PLAYER)