local function canSlide(p)
	if not P_IsObjectOnGround(p.mo)
	or P_PlayerInPain(p)
	or p.playerstate == PST_DEAD
	or not p.mo.standingslope
		return false
	end
	return true
end

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or (p.mo.skin ~= "smwmario" and p.mo.skin ~= "smwluigi") return end
	
	if (p.cmd.buttons & BT_CUSTOM2)
	and canSlide(p)
		if p.speed < 5*FU
			local s = p.mo.standingslope
			local ang = s.xydirection
			local x = cos(ang)
			local y = sin(ang)
			if P_GetZAt(s, p.mo.x+32*x, p.mo.y+32*y) > p.mo.z
				ang = $+ANGLE_180
			end
			P_InstaThrust(p.mo, ang, 5*FU)
		end
		p.pflags = $1|PF_SPINNING
		p.mo.state = S_PLAY_ROLL
		p.smwmslide = true
	end
	
	if not (p.pflags & PF_SPINNING)
		p.smwmslide = false
	end
	
	if p.smwmslide
		P_ButteredSlope(p.mo)
	end
end)

addHook("PlayerHeight", function(p)
	if not (p.mo and p.mo.valid)
	or (p.mo.skin ~= "smwmario" and p.mo.skin ~= "smwluigi") return end
	
	if p.smwmslide return P_GetPlayerSpinHeight(p) end
end)

addHook("PlayerCanEnterSpinGaps", function(p)
	if not (p.mo and p.mo.valid)
	or (p.mo.skin ~= "smwmario" and p.mo.skin ~= "smwluigi") return end
	
	if p.smwmslide return true end
end)